// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMEUIMM_APPBAR_H
#define _LIBGNOMEUIMM_APPBAR_H

#include <glibmm.h>

// -*- C++ -*-
/* $Id: appbar.hg,v 1.9 2002/04/11 20:41:12 murrayc Exp $ */

/* appbar.h
 * 
 * Copyright (C) 1998 EMC Capital Management Inc.
 * Developed by Havoc Pennington <hp@pobox.com>
 *
 * Copyright (C) 1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgnomeui/gnome-appbar.h>
#include <gtkmm/box.h>
#include <gtkmm/progressbar.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GnomeAppBar GnomeAppBar;
typedef struct _GnomeAppBarClass GnomeAppBarClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace UI
{ class AppBar_Class; } // namespace UI

} // namespace Gnome
namespace Gnome
{

namespace UI
{


class AppBar : public Gtk::HBox
{
   public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef AppBar CppObjectType;
  typedef AppBar_Class CppClassType;
  typedef GnomeAppBar BaseObjectType;
  typedef GnomeAppBarClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~AppBar();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class AppBar_Class;
  static CppClassType appbar_class_;

  AppBar(const AppBar&);
  AppBar& operator=(const AppBar&); // not implemented

protected:
  explicit AppBar(GnomeAppBar* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GnomeAppBar* gobj()             { return (GnomeAppBar*)(gobject_); }
  const GnomeAppBar* gobj() const { return (GnomeAppBar*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_clear_prompt();
  virtual void on_user_response();


private:

public:

  //: Create a AppBar.
  //- interactivity can be GNOME_PREFERENCES_NEVER, GNOME_PREFERENCES_USER,
  //- GNOME_PREFERENCES_ALWAYS.
  explicit AppBar(bool has_progress = false, bool has_status = true,
                    GnomePreferencesType interactivity = GNOME_PREFERENCES_NEVER);

  
  Gtk::ProgressBar* get_progress();
  
  Gtk::Widget* get_status();

/* Status message stack. */

  
  void set_default(const Glib::ustring& default_status);


  //: Replaces the current status with a new one.
  
  void set_status(const Glib::ustring& status);

  //: Places a new status message in the bar.
  //- Temporarily sets status message.  It is cleared by {refresh()}
  //- or set.  Does not affect the stack.
  
  void push(const Glib::ustring& status);

  //: Removes last status message.
  //- This is okay to call on empty stack.  The previous message is 
  //- displayed.
  
  void pop();

  //: Remove status on the stack.
  
  void clear_stack();

  
  void	set_progress_percentage(gfloat percentage);

  //: Reflect the current state of stack/default. 
  //- Useful to force a {set_status()} to disappear.
  
  void refresh();

  //: Prompt user for input. 
  //- Put a prompt in the appbar and wait for a response. When the 
  //- user responds or cancels, a user_response signal is emitted.
  
  void prompt(const Glib::ustring& message, bool modal = true);

   //: Remove any prompt.
  
  void clear_prompt();

  //: Get the response to the prompt, if any.
  
  Glib::ustring get_response() const;

  
  /**
   * @par Prototype:
   * <tt>void %clear_prompt()</tt>
   */
  Glib::SignalProxy0<void> signal_clear_prompt();

  
  //: Indicates use hit return or canceled.
  
  /**
   * @par Prototype:
   * <tt>void %user_response()</tt>
   */
  Glib::SignalProxy0<void> signal_user_response();


};

} /* namespace UI */
} /* namespace Gnome */

namespace Glib
{
  /** @relates Gnome::UI::AppBar */
  Gnome::UI::AppBar* wrap(GnomeAppBar* object, bool take_copy = false);
}
#endif /* _LIBGNOMEUIMM_APPBAR_H */

