
#include <libgnomeuimm/href.h>
#include <libgnomeuimm/private/href_p.h>

/* $Id: href.ccg,v 1.7 2002/01/03 12:28:01 murrayc Exp $ */


/* href.ccg
 * 
 * Copyright (C) 1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

namespace Gnome
{

namespace UI
{

HRef::HRef(const Glib::ustring& url, const Glib::ustring& label)
  : Gtk::Button(GTK_BUTTON(g_object_new(get_type(), 0)))
{
  set_url(url);
  set_label(label);
}

HRef::HRef(const Glib::ustring& url)
  : Gtk::Button(GTK_BUTTON(g_object_new(get_type(), 0)))
{
  set_url(url);
  set_label(url);
}

} /* namespace UI */
} //namespace Gnome


namespace
{
} // anonymous namespace


namespace Glib
{

Gnome::UI::HRef* wrap(GnomeHRef* object, bool take_copy /* = false */)
{
  return dynamic_cast<Gnome::UI::HRef *> (Glib::wrap_auto ((GObject*)(object), take_copy));
}

} /* namespace Glib */

namespace Gnome
{

namespace UI
{


/* The *_Class implementation: */

GType HRef_Class::get_type()
{
  if(!gtype_) // create the GType if necessary
  {
    // TODO: This is currently just optimized away, apparently with no harm.
    // Is it actually needed?
    // Make sure that the parent type has been created.
    CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(gnome_href_get_type(), (GClassInitFunc) &class_init_function);

    // Add derived versions of interfaces, if the C type implements any interfaces:
  }

  return gtype_;
}

void HRef_Class::class_init_function(BaseClassType* klass)
{
  CppClassParent::class_init_function((CppClassParent::BaseClassType*) klass);
}


Glib::ObjectBase* HRef_Class::wrap_new(GObject* o)
{
  return manage(new HRef((GnomeHRef*)(o)));
}


/* The implementation: */

HRef::HRef(GnomeHRef* castitem)
: Gtk::Button((GtkButton*)(castitem))
{}

HRef::~HRef()
{
  destroy_();
}

HRef::CppClassType HRef::href_class_; //Initialize static member.

GType HRef::get_type()
{
  return href_class_.get_type();
}

GType HRef::get_base_type()
{
  return gnome_href_get_type();
}

void HRef::set_url(const Glib::ustring& url)
{
  gnome_href_set_url(gobj(), url.c_str());
}

Glib::ustring HRef::get_url() const
{
  return Glib::convert_const_gchar_ptr_to_ustring(gnome_href_get_url(const_cast<GnomeHRef*>(gobj())));
}

void HRef::set_text(const Glib::ustring& text)
{
  gnome_href_set_text(gobj(), text.c_str());
}

Glib::ustring HRef::get_text() const
{
  return Glib::convert_const_gchar_ptr_to_ustring(gnome_href_get_text(const_cast<GnomeHRef*>(gobj())));
}


Glib::PropertyProxy<Glib::ustring> HRef::property_url()
{
  return Glib::PropertyProxy<Glib::ustring>(this, "url");
}

Glib::PropertyProxy<Glib::ustring> HRef::property_text()
{
  return Glib::PropertyProxy<Glib::ustring>(this, "text");
}


} // namespace UI

} // namespace Gnome

