
#include <libgnomeuimm/icon-sel.h>
#include <libgnomeuimm/private/icon-sel_p.h>

/* $Id: icon-sel.ccg,v 1.5 2001/12/06 01:47:05 murrayc Exp $ */


/* icon-sel.ccg
 * 
 * Copyright (C) 1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgnomeui/gnome-icon-sel.h>

namespace
{
} // anonymous namespace


namespace Glib
{

Gnome::UI::IconSelection* wrap(GnomeIconSelection* object, bool take_copy /* = false */)
{
  return dynamic_cast<Gnome::UI::IconSelection *> (Glib::wrap_auto ((GObject*)(object), take_copy));
}

} /* namespace Glib */

namespace Gnome
{

namespace UI
{


/* The *_Class implementation: */

GType IconSelection_Class::get_type()
{
  if(!gtype_) // create the GType if necessary
  {
    // TODO: This is currently just optimized away, apparently with no harm.
    // Is it actually needed?
    // Make sure that the parent type has been created.
    CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(gnome_icon_selection_get_type(), (GClassInitFunc) &class_init_function);

    // Add derived versions of interfaces, if the C type implements any interfaces:
  }

  return gtype_;
}

void IconSelection_Class::class_init_function(BaseClassType* klass)
{
  CppClassParent::class_init_function((CppClassParent::BaseClassType*) klass);
}


Glib::ObjectBase* IconSelection_Class::wrap_new(GObject* o)
{
  return manage(new IconSelection((GnomeIconSelection*)(o)));
}


/* The implementation: */

IconSelection::IconSelection(GnomeIconSelection* castitem)
: Gtk::VBox((GtkVBox*)(castitem))
{}

IconSelection::~IconSelection()
{
  destroy_();
}

IconSelection::CppClassType IconSelection::iconselection_class_; //Initialize static member.

GType IconSelection::get_type()
{
  return iconselection_class_.get_type();
}

GType IconSelection::get_base_type()
{
  return gnome_icon_selection_get_type();
}

IconSelection::IconSelection()
: Gtk::VBox((GtkVBox*)(g_object_new(get_type(), (char*)0)))
{}

void IconSelection::add_defaults()
{
  gnome_icon_selection_add_defaults(gobj());
}

void IconSelection::add_directory(const Glib::ustring& dir)
{
  gnome_icon_selection_add_directory(gobj(), dir.c_str());
}

void IconSelection::show_icons()
{
  gnome_icon_selection_show_icons(gobj());
}

void IconSelection::clear(bool not_shown)
{
  gnome_icon_selection_clear(gobj(), static_cast<int>(not_shown));
}

Glib::ustring IconSelection::get_icon(bool full_path) const
{
  return Glib::convert_return_gchar_ptr_to_ustring(gnome_icon_selection_get_icon(const_cast<GnomeIconSelection*>(gobj()), static_cast<int>(full_path)));
}

void IconSelection::select_icon(const Glib::ustring& filename)
{
  gnome_icon_selection_select_icon(gobj(), filename.c_str());
}

void IconSelection::stop_loading()
{
  gnome_icon_selection_stop_loading(gobj());
}

GtkWidget* IconSelection::get_gil()
{
  return gnome_icon_selection_get_gil(gobj());
}

GtkWidget* IconSelection::get_box()
{
  return gnome_icon_selection_get_box(gobj());
}


} // namespace UI

} // namespace Gnome

